// *** PocketMotus Windows CE ***
// Version 1.1
// Franois PESSAUX June 2001
// This program is freeware.
// Use its sources as you whant provided that you leave this copyright unchanged
// and that you drop a small word telling that I'm the author of these sources.
// Thank's a lot.
//   --Francois

#define MAX_STRINGLEN 256
#define MENU_HEIGHT 26

#define WORD_LEN 6
#define BLANK_STRING_INIT "      "

#define	MAIN_WINDOW_CLASS_NAME (TEXT ("PocketMotusWnd"))
#define CLIENT_WINDOW_CLASS_NAME (TEXT ("ClientWnd"))

extern HINSTANCE app_instance_handle ;
extern HWND main_window_handle, main_dialog_hd, main_edit_hd,
	main_timer_hd, board_window_handle, main_menubar_hd ;

extern char tmp_char_string[MAX_STRINGLEN] ;
extern TCHAR tmp_unicode_string[MAX_STRINGLEN] ;

extern int current_visible_start_turn ;
extern int number_of_turns_to_display ;
extern int page_vertical_scroll_size ;
extern int case_width, case_height ;

extern BOOL timer_flag ;
extern int timer_limit ;
extern BOOL check_flag ;

extern int remaining_time ;
extern int number_of_turns ;

struct game {
	char solution[WORD_LEN+1] ;
	char suggestion[WORD_LEN+1] ;
	int current_turn ;
	char current_known_facts[WORD_LEN+1] ;	// Letters known and are the right place.
	char **suggestions_history ;
	COLORREF **colors_history ;
};

extern struct game *current_game ;

#define WRONG_LETTER 0
#define BAD_PLACE 1
#define GOOD_PLACE 2

#define LEFT_BORDER 10
#define TOP_BORDER 10
#define CHECKER_BORDER 1

#define WRONG_LETTER_COLOR (RGB(255,255,255))
#define GOOD_PLACE_COLOR (RGB(0,255,0))
#define BAD_PLACE_COLOR (RGB(255,0,0))

#define TAGTOLONG(a,b,c,d) ((unsigned long)(((a)<<24)|((b)<<16)|((c)<<8)|(d)))
#define TABLEMAGICNUMBER TAGTOLONG('M','D','I','C')

/* DAGElement = ULONG. */
/* Bits 0-7 de poids faible = Char */
/* Bit 8 = IsBase | NextFilled */
/* Bit 9 = IsFinal */
/* Bits 10-31 = NextBase */
typedef unsigned long DAGElement ;

#define GETCHAR(foo) \
	((unsigned char) ((foo) & 0xFF))

#define GETISBASE(foo) \
	((foo) & 0x00000100)

#define GETNEXTFILLED(foo) \
	((foo) & 0x00000100)

#define GETISFINAL(foo) \
	((foo) & 0x00000200)

#define GETNEXTBASE(foo) \
	((unsigned long) ((foo) >> 10))

/* VALEUR DU <<POINTEUR>> SIGNIFIANT TRANSITION NON EXISTANTE */
#define END_TRANSITION 0x3FFFFF

extern DAGElement *automaton ;
extern unsigned long automaton_size ;
extern unsigned long initial_state ;
extern TCHAR dic_name[] ;

extern HANDLE dic_file_hd ;
extern HANDLE dic_mapping_hd ;
extern unsigned long *dic_mapped_memory ;

extern HBITMAP background_bm_handle ;
extern HBRUSH background_brush ;

#define DEFAULT_TIMER_AMOUNT 30
#define GLOBAL_TIMER_ID 1
#define STEP_TIMER_ID 2

