// *** PocketMotus Windows CE ***
// Version 1.1
// Franois PESSAUX June 2001
// This program is freeware.
// Use its sources as you whant provided that you leave this copyright unchanged
// and that you drop a small word telling that I'm the author of these sources.
// Thank's a lot.
//   --Francois

#include "stdafx.h"
#include <stdio.h>
#include <stdlib.h>




// Test if a file is a valid dictionary.
BOOL CheckValidDictionary (TCHAR *file_name)
{
	HANDLE file_hd ;
	unsigned long tmp ;
	DWORD read ;

	file_hd = CreateFile (file_name, GENERIC_READ, FILE_SHARE_READ, NULL,
		OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL) ;
	if (file_hd == INVALID_HANDLE_VALUE) {
		return (FALSE) ;
	}

	// Check magic word.
	ReadFile (file_hd, &tmp, sizeof (unsigned long), &read, NULL) ;
	if ((tmp != TABLEMAGICNUMBER) || (read != sizeof (unsigned long))) {
		CloseHandle (file_hd) ;
		return (FALSE) ;
  }

	// Check automaton size.
	ReadFile (file_hd, &tmp, sizeof (unsigned long), &read, NULL) ;
	if ((tmp == 0) || (read != sizeof (unsigned long))) {
		CloseHandle (file_hd) ;
		return (FALSE) ;
		}
	
	CloseHandle (file_hd) ;
	return (TRUE) ;
}



BOOL LoadDictionary (TCHAR *file_name) {

	dic_file_hd = CreateFileForMapping (file_name,GENERIC_READ, FILE_SHARE_READ, NULL,
		OPEN_EXISTING, 0, NULL) ;
	if (dic_file_hd == INVALID_HANDLE_VALUE) {
		return (FALSE) ;
	}

	dic_mapping_hd = CreateFileMapping (dic_file_hd, NULL, PAGE_READONLY, 0, 0, NULL) ;
	if (dic_mapping_hd == NULL) {
		CloseHandle (dic_file_hd) ;
		return (FALSE) ;
		}

	dic_mapped_memory =
		(unsigned long*) MapViewOfFile (dic_mapping_hd, FILE_MAP_READ, 0, 0, NULL) ;
	if (dic_mapped_memory == NULL) {
		CloseHandle (dic_mapping_hd) ;
		CloseHandle (dic_file_hd) ;
		return (FALSE) ;
		}

	// Check magic word.
	if (dic_mapped_memory[0] != TABLEMAGICNUMBER) {
		UnmapViewOfFile (dic_mapped_memory) ;
		CloseHandle (dic_mapping_hd) ;
		CloseHandle (dic_file_hd) ;
		return (FALSE) ;
  }

	// Check automaton size.
	automaton_size = dic_mapped_memory[1] ;
	if (automaton_size == 0) {
		UnmapViewOfFile (dic_mapped_memory) ;
		CloseHandle (dic_mapping_hd) ;
		CloseHandle (dic_file_hd) ;
		return (FALSE) ;
		}

	// Get the initial state
	initial_state = dic_mapped_memory[2] ;

	// Assign the global pointer of the automaton to the mapped memory.
	automaton = (DAGElement*) &dic_mapped_memory[3] ;
	return (TRUE) ;
}



void UnloadDictionary () {

	if (dic_mapped_memory != NULL) UnmapViewOfFile (dic_mapped_memory) ;
	dic_mapped_memory = NULL ;
	if (dic_mapping_hd != NULL) CloseHandle (dic_mapping_hd) ;
	dic_mapping_hd = NULL ;
	if (dic_file_hd != INVALID_HANDLE_VALUE) CloseHandle (dic_file_hd) ;
	dic_file_hd = NULL ;
	automaton_size = 0 ;
	automaton = NULL ;
	initial_state = END_TRANSITION ;
}
